Package: tidyfst
Title: Tidy Verbs for Fast Data Manipulation
Version: 1.8.1
Depends: R (>= 4.0.0)
Authors@R: 
    person(given = "Tian-Yuan",
           family = "Huang",
           role = c("aut", "cre"),
           email = "huang.tian-yuan@qq.com",
           comment = c(ORCID = "0000-0002-4151-3764"))
Description: A toolkit of tidy data manipulation verbs with 'data.table' as the backend.
  Combining the merits of syntax elegance from 'dplyr' and computing performance from 'data.table', 
  'tidyfst' intends to provide users with state-of-the-art data manipulation tools with least pain.
  This package is an extension of 'data.table'. While enjoying a tidy syntax, 
  it also wraps combinations of efficient functions to facilitate frequently-used data operations.  
URL: https://github.com/hope-data-science/tidyfst,
        https://hope-data-science.github.io/tidyfst/
BugReports: https://github.com/hope-data-science/tidyfst/issues
License: MIT + file LICENSE
Encoding: UTF-8
RoxygenNote: 7.3.2
Imports: data.table (>= 1.15.0), fst (>= 0.9.0), stringr (>= 1.5.0)
Suggests: knitr, rmarkdown, nycflights13, pryr, tidyr, ggplot2, dplyr,
        bench, testthat
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2024-09-16 03:48:53 UTC; Admin
Author: Tian-Yuan Huang [aut, cre] (<https://orcid.org/0000-0002-4151-3764>)
Maintainer: Tian-Yuan Huang <huang.tian-yuan@qq.com>
Repository: CRAN
Date/Publication: 2024-09-16 04:10:02 UTC
Built: R 4.4.1; ; 2024-09-17 21:04:46 UTC; unix

## ----include = FALSE----------------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  #eval = FALSE,
  comment = "#>"
)

## ----setup--------------------------------------------------------------------
library(tidyfst)

set.seed(1L)

## Create a data table
DF <- data.table(V1 = rep(c(1L, 2L), 5)[-10],
                V2 = 1:9,
                V3 = c(0.5, 1.0, 1.5),
                V4 = rep(LETTERS[1:3], 3))
copy(DF) -> DT

class(DF)
DF

## -----------------------------------------------------------------------------
### Filter rows using indices
slice_dt(DF, 3:4)

### Discard rows using negative indices
slice_dt(DF, -(3:7))

### Filter rows using a logical expression
filter_dt(DF, V2 > 5)
filter_dt(DF, V4 %in% c("A", "C"))
filter_dt(DF, V4 %chin% c("A", "C")) # fast %in% for character

### Filter rows using multiple conditions
filter_dt(DF, V1 == 1, V4 == "A")
# equals to
filter_dt(DF, V1 == 1 & V4 == "A")

### Filter unique rows
distinct_dt(DF) # unique(DF)
distinct_dt(DF, V1,V4)

### Discard rows with missing values
drop_na_dt(DF) # na.omit(DF)

### Other filters
sample_n_dt(DF, 3)      # n random rows
sample_frac_dt(DF, 0.5) # fraction of random rows
slice_max_dt(DF, V1,1)     # top n entries (includes equals)

filter_dt(DT,V4 %like% "^B")
filter_dt(DT,V2 %between% c(3, 5))
filter_dt(DT,between(V2, 3, 5, incbounds = FALSE))
filter_dt(DT,V2 %inrange% list(-1:1, 1:3))  # see also ?inrange

## -----------------------------------------------------------------------------
### Sort rows by column
arrange_dt(DF, V3)

### Sort rows in decreasing order
arrange_dt(DF, -V3)

### Sort rows based on several columns
arrange_dt(DF, V1, -V2)

## -----------------------------------------------------------------------------
### Select one column using an index (not recommended)
pull_dt(DT,3) # returns a vector
select_dt(DT,3) # returns a data.table

### Select one column using column name
select_dt(DF, V2) # returns a data.table
pull_dt(DF, V2)   # returns a vector

### Select several columns
select_dt(DF, V2, V3, V4)
select_dt(DF, V2:V4) # select columns between V2 and V4

### Exclude columns
select_dt(DF, -V2, -V3)

### Select/Exclude columns using a character vector
cols <- c("V2", "V3")
select_dt(DF,cols = cols)
select_dt(DF,cols = cols,negate = TRUE)

### Other selections
select_dt(DF, cols = paste0("V", 1:2))
relocate_dt(DF, V4) # reorder columns
select_dt(DF, "V")
select_dt(DF, "3$")
select_dt(DF, ".2")
select_dt(DF, "V1")
select_dt(DF, -"^V2")
# remove variables using "-" prior to function

## -----------------------------------------------------------------------------
### Summarise one column
summarise_dt(DF, sum(V1)) # returns a data.table
summarise_dt(DF, sumV1 = sum(V1)) # returns a data.table

### Summarise several columns
summarise_dt(DF, sum(V1), sd(V3))

### Summarise several columns and assign column names
DF %>%
  summarise_dt(sumv1 = sum(V1),
              sdv3  = sd(V3))

### Summarise a subset of rows
DT[1:4, sum(V1)]
DF %>%
  slice_dt(1:4) %>%
  summarise_dt(sum(V1))

### Misc
summarise_dt(DF, nth(V3,1))
summarise_dt(DF, nth(V3,-1))
summarise_dt(DF, nth(V3, 5))
summarise_dt(DF, uniqueN(V4))
uniqueN(DF)

## -----------------------------------------------------------------------------
### By group
# not recommended
DF %>%
  group_dt(
    by = V4,
    summarise_dt(sumV2 = sum(V2))
  )
# recommended
DF %>% 
  summarise_dt(sumV2 = sum(V2),by = V4)


### By several groups
DF %>% 
  summarise_dt(sumV2 = sum(V2),by = .(V1,V4))

### Calling function in by
DF %>% 
  summarise_dt(sumV2 = sum(V2),by = tolower(V4))


### Assigning column name in by
DF %>% 
  summarise_dt(sumV2 = sum(V2),by = .(abc = tolower(V4)))


### Using a condition in by
DF %>% 
  summarise_dt(sumV2 = sum(V2),by = V4 == "A")



### By on a subset of rows
DF %>% 
  slice_dt(1:5) %>% 
  summarise_dt(sumV1 = sum(V1),by = V4)

### Count number of observations for each group
count_dt(DF, V4)

### Add a column with number of observations for each group
add_count_dt(DF, V1)

### Retrieve the first/last/nth observation for each group
DF %>% summarise_dt(by = V4,nth(V2,1))
DF %>% summarise_dt(by = V4,nth(V2,-1))
DF %>% summarise_dt(by = V4,nth(V2,2))


## -----------------------------------------------------------------------------
### Summarise all the columns
summarise_vars(DT,.func = max)

### Summarise several columns
summarise_vars(DT,c("V1", "V2"),mean)

### Summarise several columns by group
DT %>% 
    summarise_vars(c("V1", "V2"),mean,by = V4)

## using patterns (regex)
DT %>% 
    summarise_vars("V1|V2",mean,by = V4)

## Summarise with more than one function by group
# when you can't find a way, you can always use `in_dt` to use data.table
DT %>% 
  in_dt(, by = V4, 
     c(lapply(.SD, sum),
       lapply(.SD, mean)))

### Summarise using a condition
summarise_vars(DF, is.numeric, mean)

### Modify all the columns
mutate_vars(DF, .func = rev)

### Modify several columns (dropping the others)
DF %>% 
  select_dt(cols = c("V1", "V2")) %>% 
  mutate_vars(.func = sqrt)
DF %>% 
  select_dt(-V4) %>% 
  mutate_vars(.func = exp)

### Modify several columns (keeping the others)
DF %>% 
  mutate_vars(c("V1", "V2"), sqrt)
DF %>% 
  mutate_vars(-"V4",  exp)

### Modify columns using a condition (dropping the others)
select_dt(DT,is.numeric)

### Modify columns using a condition (keeping the others)
mutate_vars(DT,is.numeric,as.integer)

### Use a complex expression
DF %>% 
  group_dt(
    by = V4,
    slice_dt(1:2) %>% 
      transmute_dt(V1 = V1,
            V2 = "X")
  )

### Use multiple expressions (with DT[,{j}])
DT %>% 
  in_dt(,{
      print(V1) #  comments here!
      print(summary(V1))
      x <- V1 + sum(V2)
     .(A = 1:.N, B = x) # last list returned as a data.table
     }
  )


## -----------------------------------------------------------------------------
### Select first/last/… row by group
DT %>% 
  group_dt(
    by = V4,
    head(1)
  )

DT %>% 
  group_dt(
    by = V4,
    tail(2)
  )

DT %>% 
  group_dt(
    by = V4,
    slice_dt(1,.N)
  )

### Select rows using a nested query
DF %>% 
  group_dt(
    by = V4,
    arrange_dt(V2) %>% 
      slice_dt(1)
  )

### Add a group counter column
DT %>% 
  mutate_dt(Grp = .GRP,by = .(V4, V1))

### Get row number of first (and last) observation by group
DT %>% summarise_dt(I = .I,by = V4)
DT %>% summarise_dt(I = .I[1],by = V4)
DT %>% summarise_dt(I = .I[c(1,.N)],by = V4)

### Handle list-columns by group

DT %>% 
  select_dt(V1,V4) %>% 
  chop_dt(V1) # return V1 as a list
DT %>% nest_dt(V4) # subsets of the data

### Grouping sets (multiple by at once)
# use data.table directly, tidyfst does not provide new methods for it yet
data.table::rollup(DT,
       .(SumV2 = sum(V2)),
       by = c("V1", "V4"))

data.table::rollup(DT,
       .(SumV2 = sum(V2), .N),
       by = c("V1", "V4"),
       id = TRUE)

data.table::cube(DT,
     .(SumV2 = sum(V2), .N),
     by = c("V1", "V4"),
     id = TRUE)

data.table::groupingsets(DT,
             .(SumV2 = sum(V2), .N),
             by   = c("V1", "V4"),
             sets = list("V1", c("V1", "V4")),
             id   = TRUE)


## ----eval=FALSE---------------------------------------------------------------
#  ### Write data to a csv file
#  fwrite(DT, "DT.csv")
#  
#  ### Write data to a tab-delimited file
#  fwrite(DT, "DT.txt", sep = "\t")
#  
#  ### Write list-column data to a csv file
#  fwrite(setDT(list(0, list(1:5))), "DT2.csv")
#  #
#  ### Read a csv / tab-delimited file
#  fread("DT.csv")
#  # fread("DT.csv", verbose = TRUE) # full details
#  fread("DT.txt", sep = "\t")
#  
#  ### Read a csv file selecting / droping columns
#  fread("DT.csv", select = c("V1", "V4"))
#  fread("DT.csv", drop = "V4")
#  # NA
#  ### Read and rbind several files
#  rbindlist(lapply(c("DT.csv", "DT.csv"), fread))
#  # c("DT.csv", "DT.csv") %>% lapply(fread) %>% rbindlist
#  

## -----------------------------------------------------------------------------
### Melt data (from wide to long)
fsetequal(DT,DF)

mDT = DT %>% longer_dt(V3,V4)
mDF = DF %>% longer_dt(-"V1|V2")

fsetequal(mDT,mDF)
mDT

### Cast data (from long to wide)
mDT %>% 
  wider_dt(V4,name = "name",value = "value")
# below is a special case and could only be done in tidyfst
mDT %>% 
  wider_dt(V4,name = "name",value = "value",fun = list)

mDT %>% 
  wider_dt(V4,name = "name",value = "value",fun = sum)

### Split
split(DT, by = "V4")


## -----------------------------------------------------------------------------
### Lead/Lag
lag_dt(1:10,n = 1)
lag_dt(1:10,n = 1:2)
lead_dt(1:10,n = 1)


## -----------------------------------------------------------------------------
x <- data.table(Id  = c("A", "B", "C", "C"),
                X1  = c(1L, 3L, 5L, 7L),
                XY  = c("x2", "x4", "x6", "x8"),
                key = "Id")

y <- data.table(Id  = c("A", "B", "B", "D"),
                Y1  = c(1L, 3L, 5L, 7L),
                XY  = c("y1", "y3", "y5", "y7"),
                key = "Id")

### left join
left_join_dt(x, y, by = "Id")

### right join
right_join_dt(x, y, by = "Id")

### inner join
inner_join_dt(x, y, by = "Id")

### full join
full_join_dt(x, y, by = "Id")

### semi join
semi_join_dt(x, y, by = "Id")

### anti join
anti_join_dt(x, y, by = "Id")


## -----------------------------------------------------------------------------
x <- data.table(1:3)
y <- data.table(4:6)
z <- data.table(7:9, 0L)
### Bind rows
rbind(x, y)
rbind(x, z, fill = TRUE)

### Bind rows using a list
rbindlist(list(x, y), idcol = TRUE)

### Bind columns
cbind(x, y)


## -----------------------------------------------------------------------------
x <- data.table(c(1, 2, 2, 3, 3))
y <- data.table(c(2, 2, 3, 4, 4))
### Intersection
fintersect(x, y)
fintersect(x, y, all = TRUE)

### Difference
fsetdiff(x, y)
fsetdiff(x, y, all = TRUE)

### Union
funion(x, y)
funion(x, y, all = TRUE)

### Equality
fsetequal(x, x[order(-V1),])
all.equal(x, x) # S3 method
setequal(x, x[order(-V1),])

test_that("count", {
  ir = as.data.table(iris)
  mt = as.data.table(mtcars)

  expect_equal(iris %>% count_dt(Species),
               ir[,.(n = .N),by = Species])

  expect_equal(
    iris %>% count_dt(Species,.name = "count"),
    ir[,.(count = .N),by = Species]
  )

  expect_equal(
    mtcars %>% count_dt(cyl,vs),
    mt[,.(n = .N),by = c("cyl","vs")][order(-n)]
  )

  expect_equal(
    mtcars %>% count_dt(cyl,vs),
    mtcars %>% count_dt("cyl|vs")
  )

})

test_that("add_count", {
  ir = as.data.table(iris)
  mt = as.data.table(mtcars)

  expect_equal(
    iris %>% add_count_dt(Species),
    copy(ir)[,n:=.N,by=Species]
  )

  expect_equal(
    iris %>% add_count_dt(Species,.name = "N"),
    copy(ir)[,N:=.N,by=Species][]
  )

  expect_equal(
    mtcars %>% add_count_dt(cyl,vs),
    copy(mt)[,n:=.N,by=.(cyl,vs)][]
  )

  expect_equal(
    mtcars %>% add_count_dt(cyl,vs),
    mtcars %>% add_count_dt("cyl|vs")
  )

})

test_that("slice", {
  ir = as.data.table(iris)

  expect_equal(
    ir %>% slice_dt(1,3),
    ir[c(1,3)]
  )
  expect_equal(
    ir %>% slice_dt(1:3),
    ir[1:3]
  )

  expect_equal(
    ir %>% slice_head_dt(3),
    ir %>% head(3)
  )
  expect_equal(
    ir %>% slice_tail_dt(3),
    ir %>% tail(3)
  )

  expect_equal(
    ir %>% slice_max_dt(Sepal.Length,3),
    ir[order(-Sepal.Length)][1:5]
  )
  expect_equal(
    ir %>% slice_min_dt(Sepal.Length,3),
    ir[order(Sepal.Length)][1:4]
  )

  expect_equal(
    ir %>% slice_max_dt(Sepal.Length,3,with_ties = FALSE),
    ir[order(-Sepal.Length)][1:3]
  )
  expect_equal(
    ir %>% slice_min_dt(Sepal.Length,3,with_ties = FALSE),
    ir[order(Sepal.Length)][1:3]
  )

})

test_that("slice by group",{
  a = as.data.table(iris)

  expect_equal(
    slice_dt(a,1:3,by = Species),
    a[,.SD[1:3],by = Species]
  )
  expect_equal(
    slice_dt(a,1:3,by = Species),
    slice_dt(a,1:3,by = "Species")
  )
  expect_equal(
    slice_dt(a,1:3,by = Species),
    slice_dt(a,1:3,by = .(Species))
  )

  expect_equal(
    slice_head_dt(a,2,by = Species),
    a[,head(.SD,2),by = Species]
  )
  expect_equal(
    slice_tail_dt(a,2,by = Species),
    a[,tail(.SD,2),by = Species]
  )

  expect_equal(
    slice_max_dt(a,Sepal.Length,3,by = Species),
    a[,.SD[Sepal.Length %in% sort(Sepal.Length,TRUE)[1:3]],by = Species]
  )
  expect_equal(
    slice_min_dt(a,Sepal.Length,3,by = Species),
    a[,.SD[Sepal.Length %in% sort(Sepal.Length)[1:3]],by = Species]
  )
})

test_that("pull", {
  expect_equal(
    mtcars %>% pull_dt(2),
    mtcars[,2]
  )

  expect_equal(
    mtcars %>% pull_dt(cyl),
    mtcars[["cyl"]]
  )

  expect_equal(
    mtcars %>% pull_dt(cyl),
    mtcars %>% pull_dt("cyl")
  )
})

test_that("summarise", {
  ir = as.data.table(iris)

  expect_equal(
    iris %>% summarise_dt(avg = mean(Sepal.Length)),
    ir[,.(avg = mean(Sepal.Length))]
  )
  expect_equal(
    iris %>% summarise_dt(avg = mean(Sepal.Length),by = Species),
    ir[,.(avg = mean(Sepal.Length)),by = Species]
  )

  expect_equal(
    iris %>% summarise_vars(is.numeric,mean) %>% as.numeric(),
    ir[,1:4] %>% colMeans() %>% as.numeric()
  )
  expect_equal(
    iris %>% summarise_vars(is.numeric,min),
    iris %>% summarise_vars(-is.factor,min)
  )
  expect_equal(
    iris %>% summarise_vars(is.numeric,min),
    iris %>% summarise_vars(1:4,min)
  )
  expect_equal(
    iris %>% summarise_vars(is.numeric,min,by ="Species"),
    ir[,lapply(.SD,min), by = "Species"]
  )
})

test_that("conversion between matrix and data.frame", {

  mm = matrix(c(1:8,NA),ncol = 3,dimnames = list(letters[1:3],LETTERS[1:3]))
  tdf = data.frame(
    row = as.factor(c("a",
                      "b","c","a","b","c","a",
                      "b","c")),
    col = as.factor(c("A",
                      "A","A","B","B","B","C",
                      "C","C")),
    value = c(1L, 2L, 3L, 4L, 5L, 6L, 7L, 8L, NA)
  )

  expect_equal(mat_df(mm),tdf)
  expect_equal(mm,df_mat(tdf,row,col,value))

})

test_that("transpose of data.frame",{
  expect_equal(
    transpose(iris),
    t_dt(iris) %>% setDT %>% setDF()
  )
})

test_that("set operations", {
  ir = as.data.table(iris)

  x = ir[c(2,3,3,4),]
  x2 = ir[2:4,]
  y = ir[c(3:5),]

  expect_equal(
    intersect_dt(x, y),
    fintersect(x,y)
  )
  expect_equal(
    intersect_dt(x, y, all=TRUE),
    fintersect(x,y, all=TRUE)
  )

  expect_equal(
    setdiff_dt(x, y),
    fsetdiff(x,y)
  )
  expect_equal(
    setdiff_dt(x, y, all=TRUE),
    fsetdiff(x,y, all=TRUE)
  )

  expect_equal(
    union_dt(x, y),
    funion(x,y)
  )
  expect_equal(
    union_dt(x, y, all=TRUE),
    funion(x,y, all=TRUE)
  )

  expect_true(setequal_dt(x, x2, all=FALSE))
  expect_false(setequal_dt(x, x2))
})

test_that("select columns", {
  ir = as.data.table(iris)

  expect_equal(
    iris %>% select_dt(Species),
    ir[,"Species"]
  )

  expect_equal(
    iris %>% select_dt(5),
    iris %>% select_dt(Species)
  )

  expect_equal(
    iris %>% select_dt(-(1:4)),
    iris %>% select_dt(Species)
  )

  expect_equal(
    iris %>% select_dt("Species"),
    iris %>% select_dt(Species)
  )

  expect_equal(
    iris %>% select_dt("Spe"),
    iris %>% select_dt(Species)
  )

  expect_equal(
    iris %>% select_dt("Pe|Se",negate = TRUE),
    iris %>% select_dt(Species)
  )

  expect_equal(
    iris %>% select_dt(is.factor),
    iris %>% select_dt(Species)
  )

  expect_equal(
    iris %>% select_dt(-is.numeric),
    iris %>% select_dt(Species)
  )

  expect_equal(
    iris %>% select_dt(cols = 5),
    iris %>% select_dt(Species)
  )

  expect_equal(
    iris %>% select_dt(cols = names(iris)[5]),
    iris %>% select_dt(Species)
  )

  expect_equal(
    iris %>% select_dt(cols = "Species"),
    iris %>% select_dt(Species)
  )

  expect_equal(
    iris %>% select_mix(1:2,is.factor),
    ir[,c(1,2,5)]
  )

})

test_that("filter a data.frame", {
  ir = as.data.table(iris)

  expect_equal(
    iris %>% filter_dt(Sepal.Length > 7),
    ir[Sepal.Length > 7]
  )

  expect_equal(
    iris %>% filter_dt(Sepal.Length > 7 & Sepal.Width > 3),
    ir[Sepal.Length > 7 & Sepal.Width > 3]
  )

  expect_equal(
    iris %>% filter_dt(Sepal.Length > 7 | Sepal.Width > 3),
    ir[Sepal.Length > 7 | Sepal.Width > 3]
  )

  expect_equal(
    iris %>% filter_dt(Sepal.Length == max(Sepal.Length)),
    ir[Sepal.Length == max(Sepal.Length)]
  )

})

test_that("impute values", {
  data = data.table(a = c(1,2,NA,2,4),b = c(T,F,T,NA,T))

  expect_equal(
    data %>% impute_dt(),
    data.table(a = c(1,2,2,2,4),b = c(T,F,T,T,T))
  )
  expect_equal(
    data %>% impute_dt(is.numeric,.func = "mean"),
    data.table(a = c(1,2,2.25,2,4),b = c(T,F,T,NA,T))
  )
  expect_equal(
    data %>% impute_dt(is.numeric,.func = "median"),
    data.table(a = c(1,2,2,2,4),b = c(T,F,T,NA,T))
  )
})

test_that("relocate columns", {
  df <- data.table(a = 1, b = 1, c = 1, d = "a", e = "a", f = "a")

  expect_equal(
    df %>% relocate_dt(f),
    data.table(f = "a",a = 1, b = 1, c = 1, d = "a", e = "a")
  )

  expect_equal(
    df %>% relocate_dt(a,how = "last"),
    data.table(b = 1, c = 1, d = "a", e = "a", f = "a",a = 1)
  )

  expect_equal(
    df %>% relocate_dt(is.character),
    data.table(d = "a", e = "a", f = "a",a = 1, b = 1, c = 1)
  )

  expect_equal(
    df %>% relocate_dt(is.numeric, how = "last"),
    data.table(d = "a", e = "a", f = "a",a = 1, b = 1, c = 1)
  )

})

test_that("import and export fst", {

  path <- paste0(tempfile(), ".fst")
  write_fst(iris, path)

  path2 <- paste0(tempfile(), ".fst")
  export_fst(iris,path2)

  expect_equal(read_fst(path,as.data.table = TRUE),import_fst(path2))
})

test_that("use fst workflow in tidyfst",{

  path <- paste0(tempfile(), ".fst")
  export_fst(iris, path)

  ft = parse_fst(path)
  ir = as.data.table(iris)

  # slice
  expect_equal(
    ft %>% slice_fst(1:3),
    ir[1:3]
  )
  expect_equal(
    ft %>% slice_fst(c(1,3)),
    ir[c(1,3)]
  )

  # select
  expect_equal(ft %>% select_fst(Sepal.Length),ir[,"Sepal.Length"])
  expect_equal(ft %>% select_fst("Sepal.Length"),ir[,"Sepal.Length"])
  expect_equal(
    ft %>% select_fst("Se"),
    ir[,.SD,.SDcols = patterns("Se")]
  )
  expect_equal(
    ft %>% select_fst(cols = names(ft)[2:3]),
    ir[,.SD,.SDcols = names(ir)[2:3]]
  )
  expect_warning(ft %>% select_fst("nothing"))

  #filter
  expect_equal(
    ft %>% filter_fst(Sepal.Width > 3),
    ir[Sepal.Width > 3]
  )
  expect_equal(
    ft %>% filter_fst(Sepal.Length > 6 & Species == "virginica" & Sepal.Width < 3),
    ir[Sepal.Length > 6 & Species == "virginica" & Sepal.Width < 3]
  )

})

test_that("mutate_when", {
  ir = as.data.table(iris)
  expect_equal(
    iris[3:8,] %>%
      mutate_when(Petal.Width == .2,
                  one = 1,Sepal.Length=2),
    ir[3:8][Petal.Width == .2,`:=`(one = 1,Sepal.Length=2)]
  )
})

test_that("mutate_vars",{
  ir = as.data.table(iris)

  sel_names = stringr::str_subset(names(ir),"Pe")
  expect_equal(
    iris %>% mutate_vars("Pe",scale),
    copy(ir)[,(sel_names):=lapply(.SD,scale),.SDcols = patterns("Pe")]
  )

  expect_equal(
    iris %>% mutate_vars(is.numeric,scale),
    iris %>% mutate_vars(-is.factor,scale)
  )

  expect_equal(
    iris %>% mutate_vars(1:2,scale),
    copy(ir)[,names(ir)[1:2]:=lapply(.SD,scale),.SDcols = 1:2]
  )

  expect_equal(
    iris %>% mutate_vars(.func = as.character),
    copy(ir)[,names(ir):=lapply(.SD,as.character)]
  )

})

test_that("distinct_dt", {

  ir = as.data.table(iris)
  mt = as.data.table(mtcars)

  expect_equal(
    iris %>% distinct_dt(),
    unique(ir)
  )

  expect_equal(
    iris %>% distinct_dt(Species),
    unique(ir[,"Species"])
  )

  expect_equal(
    iris %>% distinct_dt(Species,.keep_all = TRUE),
    unique(ir,by = "Species")
  )

  expect_equal(
    mtcars %>% distinct_dt(cyl,vs),
    unique(mt[,c("cyl","vs")])
  )

  expect_equal(
    mtcars %>% distinct_dt(cyl,vs,.keep_all = TRUE),
    unique(mt,by = c("cyl","vs"))
  )

})

test_that("from wide to long", {
  stocks = data.table(
    time = as.Date('2009-01-01') + 0:9,
    X = rnorm(10, 0, 1),
    Y = rnorm(10, 0, 2),
    Z = rnorm(10, 0, 4)
  )

  expect_equal(
    stocks %>% longer_dt(time),
    melt(stocks,id = "time",variable.name = "name")
  )
  # use regex to select grouping column(s)
  expect_equal(
    stocks %>% longer_dt(time),
    stocks %>% longer_dt("ti")
  )

})

test_that("complete a data.frame", {
  df <- data.table(
    group = c(1:2, 1),
    item_id = c(1:2, 2),
    item_name = c("a", "b", "b"),
    value1 = 1:3,
    value2 = 4:6
  )

  attach(df)

  expect_equal(
    df %>% complete_dt(group,item_id,item_name) ,
    df %>% merge.data.table(CJ(group,item_id,item_name,unique = TRUE),
                            by = c("group","item_id","item_name"),all = TRUE)
  )

  # use regex for shortcut to select colnames
  expect_equal(
    df %>% complete_dt("item"),
    df %>% complete_dt(item_id,item_name)
  )

  # to complete with self-defined combinations
  expect_equal(
    df %>% complete_dt(group=1:3,item_id=1:3,item_name=c("a","b","c")),
    df %>% merge.data.table(CJ(item_id=1:3,
                               group=1:3,
                               item_name=c("a","b","c"),
                               unique = TRUE),
                            by = c("group","item_id","item_name"),all = TRUE)
  )

})

test_that("as_dt", {
  ir = as_dt(iris)
  expect_equal(ir,as.data.table(iris))
})

test_that("in_dt",{
  ir = as_dt(iris)
  expect_equal(
    iris %>% in_dt(order(-Sepal.Length),.SD[.N],by=Species),
    ir[order(-Sepal.Length),.SD[.N],by=Species]
  )
})

test_that("sample", {

  expect_is(
    sample_n_dt(mtcars, 1),
    "data.table"
  )

  expect_is(
    sample_n_dt(mtcars, 1),
    "data.frame"
  )

  expect_is(
    sample_frac_dt(mtcars, .1),
    "data.table"
  )

  expect_is(
    sample_frac_dt(mtcars, .1),
    "data.frame"
  )

})

test_that("nest", {
  mt = as.data.table(mtcars)

  expect_equal(
    mtcars %>% nest_dt(cyl),
    mt[,.(ndt = list(.SD)),by = cyl]
  )

  expect_equal(
    mtcars %>% nest_dt(cyl,.name = "data"),
    mt[,.(data = list(.SD)),by = cyl]
  )

  expect_equal(
    mtcars %>% nest_dt(cyl),
    mtcars %>% nest_dt("cyl")
  )

  expect_equal(
    mtcars %>% nest_dt(cyl,vs),
    mtcars %>% nest_dt("cyl|vs")
  )

  expect_equal(
    mtcars %>% nest_dt(cyl,vs),
    mtcars %>% nest_dt(c("cyl","vs"))
  )

})

test_that("unnest",{
  mt = as.data.table(mtcars)

  expect_equal(
    mtcars %>% nest_dt("cyl") %>%
      unnest_dt(ndt),
    mt[,.(ndt = list(.SD)),by = .(cyl)][,
      unlist(ndt,recursive = FALSE),
      by = cyl
    ]
  )

  expect_equal(
    mtcars %>% nest_dt("cyl|vs") %>%
      unnest_dt(ndt),
    mtcars %>% nest_dt("cyl|vs") %>%
      unnest_dt("ndt")
  )
})

test_that("squeeze/chop/unchop",{
  expect_equal(
    iris %>% squeeze_dt(1:2),
    iris %>% squeeze_dt("Se")
  )

  df <- data.table(x = c(1, 1, 1, 2, 2, 3), y = 1:6, z = 6:1)
  expect_equal(
    df %>% chop_dt(y,z),
    df[,lapply(.SD,list),by = x]
  )

  expect_equal(
    df %>% chop_dt(y,z) %>% unchop_dt(y,z),
    df
  )

})

test_that("uncount", {
  df <- data.table(x = c("a", "b"), n = c(1, 2))

  expect_equal(
    uncount_dt(df, n),
    data.table(x = c("a","b","b"))
  )

  expect_equal(
    uncount_dt(df,n,FALSE),
    data.table(x = c("a","b","b"),n = c(1,2,2))
  )

})

test_that("arrange a data.frame", {

  ir = as.data.table(iris)

  expect_equal(iris %>% arrange_dt(Sepal.Length),ir[order(Sepal.Length)])

  expect_equal(iris %>% arrange_dt(-Sepal.Length),ir[order(-Sepal.Length)])

  expect_equal(iris %>% arrange_dt(Sepal.Length,Petal.Length),
               ir[order(Sepal.Length,Petal.Length)])

  expect_equal(iris %>% arrange_dt(Sepal.Length,-Petal.Length),
               ir[order(Sepal.Length,-Petal.Length)])
})

test_that("convert data.frame from long to wide", {

  stocks = data.table(
    time = as.Date('2009-01-01') + 0:9,
    X = rnorm(10, 0, 1),
    Y = rnorm(10, 0, 2),
    Z = rnorm(10, 0, 4)
  )

  stocks %>%
    longer_dt(time) -> longer_stocks

  expect_equal(
    longer_stocks %>%
      wider_dt("time",
               name = "name",
               value = "value"),
    stocks,check.attributes = FALSE
  )
})

test_that("drop na", {
  df <- data.table(x = c(1, 2, NA), y = c("a", NA, "b"))

  expect_equal(
    df %>% drop_na_dt(),
    na.omit(df)
  )

  expect_equal(
    df %>% drop_na_dt(x),
    df[!is.na(x)]
  )

  expect_equal(
    df %>% drop_na_dt(x,y),
    df[!is.na(x) & !is.na(y)]
  )

})

test_that("replace na or anything",{
  df <- data.table(x = c(1, 2, NA), y = c("a", NA, "b"))

  expect_equal(
    df %>% replace_na_dt(to = 0),
    df %>% replace_na_dt(x,y,to = 0)
  )

  expect_equal(
    df %>% replace_na_dt(to = 0),
    data.table(x = c(1, 2, 0), y = c("a", "0", "b"))
  )

  expect_equal(
    df %>% replace_na_dt(x,to = 0),
    setnafill(copy(df),fill = 0,cols = "x")
  )

  expect_equal(
    df %>% replace_dt(x,from = 1,to = 3),
    data.table(x = c(3, 2, NA), y = c("a", NA, "b"))
  )

})

test_that("fill na",{
  df <- data.table(x = c(1, 2, NA), y = c("a", NA, "b"))

  expect_equal(
    df %>% fill_na_dt(x),
    setnafill(copy(df),type = "locf",cols = "x")
  )

  expect_equal(
    df %>% fill_na_dt(y,direction = "up"),
    data.table(x = c(1, 2, NA), y = c("a", "b", "b"))
  )

  expect_equal(
    df %>% fill_na_dt(),
    data.table(x = c(1, 2, 2), y = c("a", "a", "b"))
  )

})

test_that("delete na cols",{
  x = data.table(x = c(1, 2, NA, 3), y = c(NA, NA, 4, 5),z = rep(NA,4))

  expect_equal(
    x %>% delete_na_cols(),
    x[,1:2]
  )

  expect_equal(
    x %>% delete_na_cols(prop = 0.5),
    x[,1]
  )

  expect_equal(
    x %>% delete_na_cols(n = 2),
    x[,1]
  )

})

test_that("delete na rows",{
  x = data.table(x = c(1, 2, NA, 3), y = c(NA, NA, 4, 5),z = rep(NA,4))

  expect_equal(
    x %>% delete_na_rows(prop = 0.6),
    x[4]
  )

  expect_equal(
    x %>% delete_na_rows(prop = 0.6),
    x %>% delete_na_rows(n = 2)
  )
})

test_that("rename columns", {
  ir = as.data.table(iris)
  expect_equal(
    iris %>%
      rename_dt(sl = Sepal.Length,sw = Sepal.Width) ,
    setnames(copy(ir),old = 1:2,new = c("sl","sw"))
  )

  expect_equal(
    iris %>% rename_with_dt(toupper),
    copy(ir) %>% setnames(old = names(ir),new = names(ir) %>% toupper())
  )

  expect_equal(
    iris %>% rename_with_dt(toupper,"^Pe"),
    copy(ir) %>% setnames(old = 3:4,new = names(iris)[3:4] %>% toupper())
  )

})

test_that("group computation", {

  ir = as.data.table(iris)
  expect_equal(
    iris %>% group_dt(by = Species,slice_dt(1:2)),
    ir[,.SD[1:2],by = Species]
  )
  expect_equal(
    iris %>% group_dt(Species,filter_dt(Sepal.Length == max(Sepal.Length))),
    ir[,.SD[Sepal.Length == max(Sepal.Length)],by = Species]
  )
  expect_equal(
    iris %>% group_dt(Species,
                      mutate_dt(max= max(Sepal.Length)) %>%
                        summarise_dt(sum=sum(Sepal.Length))),
    copy(ir)[,max:=max(Sepal.Length),by = Species][
      ,.(sum=sum(Sepal.Length)),by = Species]
  )


})

test_that("rowwise computation",{
  df <- data.table(x = 1:2, y = 3:4, z = 4:5)

  expect_equal(
    df %>% rowwise_dt(
      mutate_dt(m = min(c(x, y, z)))
    ),
    copy(df)[,m:=pmin(x,y,z)]
  )

})

test_that("use group by in tidyfst",{

  # group by 1 variable
  a = as.data.table(iris)
  expect_equal(
    a %>%
      group_by_dt(Species) %>%
      group_exe_dt(head(1)),
    a[,.SD[1],by = Species],
    check.attributes = FALSE
  )
  expect_equal(
    a %>%
      group_by_dt(Species) %>%
      group_exe_dt(
        head(3) %>%
          summarise_dt(sum = sum(Sepal.Length))
      ),
    a[,.SD[1:3],by = Species][,.(sum=sum(Sepal.Length)),by = Species],
    check.attributes = FALSE
  )

  # group by more than 1 variable
  mt = as.data.table(mtcars)
  expect_equal(
    mt %>%
      group_by_dt("cyl|am") %>%
      group_exe_dt(
        summarise_dt(mpg_sum = sum(mpg))
      ),
    mt[,.(mpg_sum=sum(mpg)),keyby=c("cyl","am")],
    check.attributes = FALSE
  )
  expect_equal(
    mt %>%
      group_by_dt("cyl|am") %>%
      group_exe_dt(
        summarise_dt(mpg_sum = sum(mpg))
      ),
    mtcars %>%
      group_by_dt(cols = c("cyl","am")) %>%
      group_exe_dt(
        summarise_dt(mpg_sum = sum(mpg))
      )
  )
})

test_that("separate a column", {
  df <- data.table(x = c(NA, "a.b", "a.d", "b.c"))

  expect_equal(
    df %>% separate_dt(x, c("A", "B")),
    data.table(A=c(NA,"a","a","b"),B=c(NA,"b","d","c"))
  )

  expect_equal(
    df %>% separate_dt(x, c("A", "B")),
    df %>% separate_dt("x", c("A", "B"))
  )

  expect_equal(
    df %>% separate_dt(x,into = c(NA,"B")),
    data.table(B=c(NA,"b","d","c"))
  )
})

test_that("trun rownames to column or column to rownames", {

  expect_equal(
    mtcars %>% rn_col(),
    as.data.table(mtcars)[,rowname := rownames(mtcars)] %>%
      relocate_dt(rowname)
  )

  expect_equal(
    mtcars %>% rn_col("rn"),
    as.data.table(mtcars)[,rn := rownames(mtcars)] %>%
      relocate_dt(rn)
  )

  expect_equal(
    mtcars %>% rn_col() %>% col_rn(),
    mtcars
  )
})

test_that("lag and lead", {
  expect_equal(
    lead_dt(1:5),
    shift(1:5,type = "lead")
  )
  expect_equal(
    lag_dt(1:5),
    shift(1:5,type = "lag")
  )
  expect_equal(
    lag_dt(1:5,n = 2),
    shift(1:5,n = 2,type = "lag")
  )
  expect_equal(
    lead_dt(1:5,n = 2,fill = 0),
    shift(1:5,n = 2,type = "lead",fill = 0)
  )
})

test_that("join", {

  workers = fread("
    name company
    Nick Acme
    John Ajax
    Daniela Ajax
")

  positions = fread("
    name position
    John designer
    Daniela engineer
    Cathie manager
")


  expect_equal(
    workers %>% inner_join_dt(positions),
    workers %>% merge.data.table(positions)
  )
  expect_equal(
    workers %>% left_join_dt(positions),
    workers %>% merge.data.table(positions,all.x = TRUE)
  )
  expect_equal(
    workers %>% right_join_dt(positions),
    workers %>% merge.data.table(positions,all.y = TRUE)
  )
  expect_equal(
    workers %>% full_join_dt(positions),
    workers %>% merge.data.table(positions,all = TRUE)
  )
  expect_equal(
    workers %>% anti_join_dt(positions),
    workers[!positions,on = "name"]
  )
  expect_equal(
    workers %>% semi_join_dt(positions),
    fsetdiff(workers,workers[!positions,on = "name"])
  )
})

test_that("recode variables", {
  x = 1:10
  expect_equal(
    rec_num(x, rec = "1:3=1; 4:6=2"),
    c(rep(1,3),rep(2,3),7:10)
  )
  expect_equal(
    rec_num(x, rec = "1:3=1; 4:6=2",keep = FALSE),
    c(rep(1,3),rep(2,3),rep(NA,4))
  )

  y = letters[1:5]
  expect_equal(
    rec_char(y,rec = "a=A;b=B"),
    c("A","B","c","d","e")
  )
  expect_equal(
    rec_char(y,rec = "a,b=A;c,d=B"),
    c("A","A","B","B","e")
  )
  expect_equal(
    rec_char(y,rec = "a,b=A;c,d=B",keep = FALSE),
    c("A","A","B","B",NA)
  )
})

test_that("unite a data.frame", {

  df <- expand.grid(x = c("a", NA), y = c("b", NA))
  expect_equal(
    df %>% unite_dt("z", x:y, remove = FALSE),
    data.table(
      x = as.factor(c("a", NA, "a", NA)),
      y = as.factor(c("b", "b", NA, NA)),
      z = c("a_b", NA, NA, NA)
    ),check.attributes = FALSE
  )

  expect_equal(
    df %>% unite_dt("z", x:y, na2char = TRUE, remove = FALSE),
    data.table(
      x = as.factor(c("a", NA, "a", NA)),
      y = as.factor(c("b", "b", NA, NA)),
      z = c("a_b", "NA_b", "a_NA", "NA_NA")
    ),check.attributes = FALSE
  )

  expect_equal(
    df %>% unite_dt("xy", x:y, remove = FALSE),
    data.table(
      x = as.factor(c("a", NA, "a", NA)),
      y = as.factor(c("b", "b", NA, NA)),
      xy = c("a_b", NA, NA, NA)
    ),check.attributes = FALSE
  )
})

test_that("mutate and transmute", {

   ir = as.data.table(iris)

  expect_equal(
    iris %>% mutate_dt(one = 1,Sepal.Length = Sepal.Length + 1),
    copy(ir)[,`:=`(one = 1,Sepal.Length = Sepal.Length + 1)]
  )

  expect_equal(
    iris %>% mutate_dt(id = 1:.N,grp = .GRP,by = Species),
    copy(ir)[,`:=`(id = 1:.N,grp = .GRP),by = Species]
  )

  expect_equal(
    iris %>% transmute_dt(one = 1,Sepal.Length = Sepal.Length + 1),
    ir[,.(one = 1,Sepal.Length = Sepal.Length + 1)]
  )

})

---
title: "Example 3: Reshape"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Example 3: Reshape}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```
  When I design `longer_dt` and `wider_dt`, I could find the `pivot_longer` and `pivot_wider` in `tidyr` and `melt` and `dcast` in `data.table`. Still, designing this API is not easy, as my goal is to let users use it with least pain. Here we would try to reproduce the results in the vignette of `tidyr`(<https://tidyr.tidyverse.org/articles/pivot.html>). First load the packages:
```{r setup}
library(tidyfst)
library(tidyr)
```

## Longer
  First inspect the data:
```{r}
relig_income
```
  In `tidyr`, to get the longer format you need:
```{r,eval=FALSE}
relig_income %>% 
  pivot_longer(-religion, names_to = "income", values_to = "count")
```
  In `tidyfst`, we have:
```{r,warning=FALSE}
relig_income %>% 
  longer_dt("religion",name = "income",value = "count")
```
  Another example from `tidyr`:
```{r,eval=FALSE}
billboard

# tidyr way:
 billboard %>%
   pivot_longer(
     cols = starts_with("wk"),
     names_to = "week",
     values_to = "rank",
     values_drop_na = TRUE
   )

# tidyfst way:
billboard %>% 
  longer_dt(-"wk",
            name = "week",
            value = "rank",
            na.rm = TRUE
            )
# regex could select the groups to keep, and minus could select the reverse
```
A warning would could come out because the merging column has different data types and do the coercion automatically.
    
## Wider

```{r}
## data
fish_encounters

## tidyr way:
fish_encounters %>% 
  pivot_wider(names_from = station, values_from = seen)

## tidyfst way:
fish_encounters %>% 
  wider_dt(name = "station",value = "seen")

# if no keeped groups are selected, use all except for name and value columns
```
    
  If you want to fill with 0s, use:
```{r}
fish_encounters %>% 
  wider_dt(name = "station",value = "seen",fill = 0)
```
  Note that the parameter of `name` and `value` should always be provided and should be explicit called (with the parameter names attached).

## More complicated example
This example comes from data.table (<https://rdatatable.gitlab.io/data.table/articles/datatable-reshape.html>), and has been used in tidyr too. We'll try to do it in tidyfst in this example.
If we have a data.frame as below:
```{r}
family <- fread("family_id age_mother dob_child1 dob_child2 dob_child3 gender_child1 gender_child2 gender_child3
1         30 1998-11-26 2000-01-29         NA             1             2            NA
2         27 1996-06-22         NA         NA             2            NA            NA
3         26 2002-07-11 2004-04-05 2007-09-02             2             2             1
4         32 2004-10-10 2009-08-27 2012-07-21             1             1             1
5         29 2000-12-05 2005-02-28         NA             2             1            NA")

family
```
And want to reshape the data.table to be like this:
```{r}
#     family_id age_mother  child        dob gender
#         <int>      <int> <char>     <char> <char>
#  1:         1         30 child1 1998-11-26      1
#  2:         1         30 child2 2000-01-29      2
#  3:         1         30 child3       <NA>   <NA>
#  4:         2         27 child1 1996-06-22      2
#  5:         2         27 child2       <NA>   <NA>
#  6:         2         27 child3       <NA>   <NA>
#  7:         3         26 child1 2002-07-11      2
#  8:         3         26 child2 2004-04-05      2
#  9:         3         26 child3 2007-09-02      1
# 10:         4         32 child1 2004-10-10      1
# 11:         4         32 child2 2009-08-27      1
# 12:         4         32 child3 2012-07-21      1
# 13:         5         29 child1 2000-12-05      2
# 14:         5         29 child2 2005-02-28      1
# 15:         5         29 child3       <NA>   <NA>
```

The `data.table::dcast` and `tidyr::pivot_longer` could transfer it in one step, however, not so easy to understand. Here we'll do it step by step to see what actually happens in this transfer.

```{r,warning=FALSE}
family %>% 
  longer_dt(1:2) %>% 
  separate_dt("name",into = c("class","child")) %>% 
  wider_dt(-"class|value",
           name = "class",
           value = "value")
```

In such a process, we could find that we actually get a longer table, then separate it, and wider it later. *tidyfst* is not going to support the complicated transfer in one step, because it might be easier to implement, but much harder to understand 3 procedures in 1 step. If you still prefer that way, use `data.table::dcast` and `tidyr::pivot_longer` instead.

---
title: "Example 1: Basic usage"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Example 1: Basic usage}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  eval = FALSE
)
```

# Use tidyfst just like dplyr
This part of vignette has referred to `dplyr`'s vignette in <https://dplyr.tidyverse.org/articles/dplyr.html>. We'll try to reproduce all the results. First load the needed packages.

```{r}
library(tidyfst)
library(nycflights13)
library(data.table)

data.table(flights)
```

## Filter rows with `filter_dt()`
```{r}
filter_dt(flights, month == 1 & day == 1)
```
Note that comma could not be used in the expressions. Which means `filter_dt(flights, month == 1,day == 1)` would return error.
## Arrange rows with `arrange_dt()`
```{r}
arrange_dt(flights, year, month, day)
```

  Use `-` (minus symbol) to order a column in descending order:
```{r}
arrange_dt(flights, -arr_delay)
```

## Select columns with `select_dt()`

```{r}
select_dt(flights, year, month, day)
```

  `select_dt(flights, year:day)` and `select_dt(flights, -(year:day))` are not supported. But I have added a feature to help select with regular expression, which means you can:
```{r}
select_dt(flights, "^dep")
```
  The rename process is almost the same as that in `dplyr`:
```{r}
select_dt(flights, tail_num = tailnum)
rename_dt(flights, tail_num = tailnum)
```
  
## Add new columns with `mutate_dt()`
```{r}
mutate_dt(flights,
  gain = arr_delay - dep_delay,
  speed = distance / air_time * 60
)
```
  
  However, if you just create the column, please split them. The following codes would not work:
```{r,eval=FALSE}
mutate_dt(flights,
  gain = arr_delay - dep_delay,
  gain_per_hour = gain / (air_time / 60)
)
```
  Instead, use:
```{r}
mutate_dt(flights,gain = arr_delay - dep_delay) %>%
  mutate_dt(gain_per_hour = gain / (air_time / 60))
```
  
  If you only want to keep the new variables, use `transmute_dt()`:
```{r}
transmute_dt(flights,
  gain = arr_delay - dep_delay
)
```
  
## Summarise values with `summarise_dt()`
```{r}
summarise_dt(flights,
  delay = mean(dep_delay, na.rm = TRUE)
)
```

## Randomly sample rows with `sample_n_dt()` and `sample_frac_dt()`
```{r}
sample_n_dt(flights, 10)
sample_frac_dt(flights, 0.01)
```

## Grouped operations
  For the below `dplyr` codes:
```{r,eval=FALSE}
by_tailnum <- group_by(flights, tailnum)
delay <- summarise(by_tailnum,
  count = n(),
  dist = mean(distance, na.rm = TRUE),
  delay = mean(arr_delay, na.rm = TRUE))
delay <- filter(delay, count > 20, dist < 2000)
```
  We could get it via:
```{r}
flights %>% 
  summarise_dt( count = .N,
  dist = mean(distance, na.rm = TRUE),
  delay = mean(arr_delay, na.rm = TRUE),by = tailnum)
```
  `summarise_dt` (or `summarize_dt`) has a parameter "by", you can specify the group.
  We could find the number of planes and the number of flights that go to each possible destination:
```{r}
# the dplyr syntax:
# destinations <- group_by(flights, dest)
# summarise(destinations,
#   planes = n_distinct(tailnum),
#   flights = n()
# )

summarise_dt(flights,planes = uniqueN(tailnum),flights = .N,by = dest) %>% 
  arrange_dt(dest)

```
  If you need to group by many variables, use:
```{r}
# the dplyr syntax:
# daily <- group_by(flights, year, month, day)
# (per_day   <- summarise(daily, flights = n()))

flights %>% 
  summarise_dt(by = .(year,month,day),flights = .N)

# (per_month <- summarise(per_day, flights = sum(flights)))
flights %>% 
  summarise_dt(by = .(year,month,day),flights = .N) %>% 
  summarise_dt(by = .(year,month),flights = sum(flights))

# (per_year  <- summarise(per_month, flights = sum(flights)))
flights %>% 
  summarise_dt(by = .(year,month,day),flights = .N) %>% 
  summarise_dt(by = .(year,month),flights = sum(flights)) %>% 
  summarise_dt(by = .(year),flights = sum(flights))
```
  
# Comparison with data.table syntax
  *tidyfst* provides a tidy syntax for *data.table*. For such design, *tidyfst* never runs faster than the analogous *data.table* codes. Nevertheless, it facilitate the dplyr-users to gain the computation performance in no time and guide them to learn more about data.table for speed.
  Below, we'll compare the syntax of `tidyfst` and `data.table` (referring to  [Introduction to data.table](https://rdatatable.gitlab.io/data.table/articles/datatable-intro.html)). This could let you know how they are different, and let users to choose their preference. Ideally, *tidyfst* will lead even more users to learn more about *data.table* and its wonderful features, so as to design more extentions for *tidyfst* in the future.
  
## Data
Because we want a more stable data source, here we'll use the flight data from the above `nycflights13` package.
```{r}
library(tidyfst)
library(data.table)
library(nycflights13)

flights = data.table(flights) %>% na.omit()
```

## Subset rows
```{r}
# data.table
head(flights[origin == "JFK" & month == 6L])
flights[1:2]
flights[order(origin, -dest)] 

# tidyfst
flights %>% 
  filter_dt(origin == "JFK" & month == 6L) %>% 
  head()
flights %>% slice_dt(1:2)
flights %>% arrange_dt(origin,-dest)
```

## Select column(s)
```{r}
# data.table
flights[, list(arr_delay)]
flights[, .(arr_delay, dep_delay)]
flights[, .(delay_arr = arr_delay, delay_dep = dep_delay)]

# tidyfst
flights %>% select_dt(arr_delay)
flights %>% select_dt(arr_delay, dep_delay)
flights %>% transmute_dt(delay_arr = arr_delay, delay_dep = dep_delay)
```

## Mixed computation
```{r}
# data.table
flights[, sum( (arr_delay + dep_delay) < 0)]
flights[origin == "JFK" & month == 6L,
               .(m_arr = mean(arr_delay), m_dep = mean(dep_delay))]
flights[origin == "JFK" & month == 6L, length(dest)]
flights[origin == "JFK" & month == 6L, .N]

# tidyfst
flights %>% summarise_dt(sum( (arr_delay + dep_delay) < 0))
flights %>% 
  filter_dt(origin == "JFK" & month == 6L) %>% 
  summarise_dt(m_arr = mean(arr_delay), m_dep = mean(dep_delay))
flights %>% 
  filter_dt(origin == "JFK" & month == 6L) %>% 
  nrow()
flights %>% 
  filter_dt(origin == "JFK" & month == 6L) %>% 
  count_dt()
flights %>% 
  filter_dt(origin == "JFK" & month == 6L) %>% 
  summarise_dt(.N)
```
  In the above examples, we could learn that in *tidyfst*, you could still use the methods in data.table, such as `.N`.
  
## Refer to columns by names
```{r}
# data.table
flights[, c("arr_delay", "dep_delay")]

select_cols = c("arr_delay", "dep_delay")
flights[ , ..select_cols]
flights[ , select_cols, with = FALSE]

flights[, !c("arr_delay", "dep_delay")]
flights[, -c("arr_delay", "dep_delay")]

# returns year,month and day
flights[, year:day]
# returns day, month and year
flights[, day:year]
# returns all columns except year, month and day
flights[, -(year:day)]
flights[, !(year:day)]

# tidyfst
flights %>% select_dt(c("arr_delay", "dep_delay"))

select_cols = c("arr_delay", "dep_delay")
flights %>% select_dt(cols = select_cols)

flights %>% select_dt(-arr_delay,-dep_delay)

flights %>% select_dt(year:day)
flights %>% select_dt(day:year)
flights %>% select_dt(-(year:day))
flights %>% select_dt(!(year:day))
```

## Aggregations
```{r}
# data.table
flights[, .N, by = .(origin)]
flights[carrier == "AA", .N, by = origin]
flights[carrier == "AA", .N, by = .(origin, dest)]
flights[carrier == "AA",
        .(mean(arr_delay), mean(dep_delay)),
        by = .(origin, dest, month)]

# tidyfst
flights %>% count_dt(origin) # sort by default
flights %>% filter_dt(carrier == "AA") %>% count_dt(origin)
flights %>% filter_dt(carrier == "AA") %>% count_dt(origin,dest)
flights %>% filter_dt(carrier == "AA") %>% 
  summarise_dt(mean(arr_delay), mean(dep_delay),
               by = .(origin, dest, month))
```
  Note that currently `keyby` is not used in *tidyfst*. This featuer might be included in the future for better performance in order-independent tasks. Moreover, `count_dt` is sorted automatically by the counted number, this could be controlled by the parameter "sort".
```{r}
# data.table
flights[carrier == "AA", .N, by = .(origin, dest)][order(origin, -dest)]
flights[, .N, .(dep_delay>0, arr_delay>0)]

# tidyfst
flights %>% 
  filter_dt(carrier == "AA") %>% 
  count_dt(origin,dest,sort = FALSE) %>% 
  arrange_dt(origin,-dest)
flights %>% 
  summarise_dt(.N,by = .(dep_delay>0, arr_delay>0))
```
  Now let's try a more complex example:
```{r}
# data.table
flights[carrier == "AA", 
        lapply(.SD, mean), 
        by = .(origin, dest, month), 
        .SDcols = c("arr_delay", "dep_delay")] 

# tidyfst
flights %>% 
  filter_dt(carrier == "AA") %>% 
  group_dt(
    by = .(origin, dest, month),
    at_dt("_delay",summarise_dt,mean)
           )
```
  Let me explain what happens here, especially in `group_dt`. First filter by condition `carrier == "AA"`, then group by three variables, which are `origin, dest, month`. Last, summarise by columns with "_delay" in the column names and get the mean value of all such variables(with "_delay" in their column names). This is a very creative design, utilizing `.SD` in *data.table* and upgrade the `group_by` function in *dplyr* (because you never need to `ungroup` now, just put the group operations in the `group_dt`). And **you can pipe in the group_dt function**. Let's play with it a little bit further:
```{r}
flights %>% 
  filter_dt(carrier == "AA") %>% 
  group_dt(
    by = .(origin, dest, month),
    at_dt("_delay",summarise_dt,mean) %>% 
      mutate_dt(sum = dep_delay + arr_delay)
           )
```
  However, I don't recommend using it if you don't acutually need it for group computation (just start another pipe follows `group_dt`).
  Now let's end with some easy examples:
```{r}
# data.table
flights[, head(.SD, 2), by = month]

# tidyfst
flights %>% 
  group_dt(by = month,head(2))
```
  Deep inside, *tidyfst* is born from *dplyr* and *data.table*, and use *stringr* to make flexible APIs, so as to bring their superiority into full play.
  
  
  
  

---
title: "Performance"
output: rmarkdown::html_vignette
author: Tian-Yuan Huang (huang.tian-yuan@qq.com)
vignette: >
  %\VignetteIndexEntry{Performance}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  warning = FALSE,
  comment = "#>"
)
```
  One may wonder how fast is *tidyfst*. Well, it depends. Generally, it is as fast as *data.table* because it is backed by it, but it would spend extra time on the generation of data.table codes. This extra time is marginal on large (and even small) data sets.<br><br>
  Now let's do a test to compare the performance of *tidyfst*, *data.table* and *dplyr*. In the vignette we'll use a small data set. The example was provided by the *data.table* package (<https://h2oai.github.io/db-benchmark/>) and tweaked here. These tests are based on computation by groups.<br><br>
  First let's load the package and generate some data.<br><br>
```{r setup}
# load packages
library(tidyfst)
library(data.table)
library(dplyr)
library(bench)

# generate the data
# if you have a HPC and want to try larger data sets, increase N
N = 1e4 
K = 1e2

set.seed(2020)

cat(sprintf("Producing data of %s rows and %s K groups factors\n", N, K))

DT = data.table(

  id1 = sample(sprintf("id%03d",1:K), N, TRUE),      # large groups (char)

  id2 = sample(sprintf("id%03d",1:K), N, TRUE),      # large groups (char)

  id3 = sample(sprintf("id%010d",1:(N/K)), N, TRUE), # small groups (char)

  id4 = sample(K, N, TRUE),                          # large groups (int)

  id5 = sample(K, N, TRUE),                          # large groups (int)

  id6 = sample(N/K, N, TRUE),                        # small groups (int)

  v1 =  sample(5, N, TRUE),                          # int in range [1,5]

  v2 =  sample(5, N, TRUE),                          # int in range [1,5]

  v3 =  round(runif(N,max=100),4)                    # numeric e.g. 23.5749

)

object_size(DT)
```
  This data is rather small, the size is around 527 Kb. However, with the *bench* package, we could detect the difference by increasing iteration times. In this way, examples listed here could be implemented even on relatively low performance computers. 
  
## Q1 
  Here, we try to get median and standard deviation by groups.After dplyr v1.0.0, the regrouping feature could be confusing sometimes (comes with warning message). If you are using it, make sure they are in the right groups before grouped computation. In tidyfst and data.table, we have "by" parameter to specify the groups. Here we would not check if the results are equal, because dplyr will return a tibble class even when we input a data.table in the first place. The iteration time is 10 for each of the test below.
```{r}
bench::mark(
  data.table = DT[,.(median_v3 = median(v3),
                     sd_v3 = sd(v3)),
                  by = .(id4,id5)],
  tidyfst = DT %>%
    summarise_dt(
      by = c("id4", "id5"),
      median_v3 = median(v3),
      sd_v3 = sd(v3)
    ),
  dplyr = DT %>%
    group_by(id4,id5,.drop = TRUE) %>%
    summarise(median_v3 = median(v3),sd_v3 = sd(v3)),
  check = FALSE,iterations = 10
) -> q1

q1
```
  We could find that spent time of tidyfst and data.table are quite similar, but much less than dplyr.

## Q2 
  This example performs quite similar to the above one. *tidyfst* might spend a tiny little more time and space on code translation than *data.table*, but still performs much better than *dplyr*.
```{r}
bench::mark(
  data.table =DT[,.(range_v1_v2 = max(v1) - min(v2)),by = id3],
  tidyfst = DT %>% summarise_dt(
    by = id3,
    range_v1_v2 = max(v1) - min(v2)
  ),
  dplyr = DT %>%
    group_by(id3,.drop = TRUE) %>%
    summarise(range_v1_v2 = max(v1) - min(v2)),
  check = FALSE,iterations = 10
) -> q2

q2
```

## Q3
  Here we'll display a rather different test to show the flexibly in *tidyfst*. In *tidyfst*, if your code writes more like *data.table*, the codes could speed up. If you write it more like *dplyr*, the codes might be more readable but slows down. In *tidyfst*, there is `in_dt` function for you to write data.table codes to gain speed when you meet a bottomneck.<br><br>
  In the following example, we use the exact same syntax of *data.table* in `tidyfst::in_dt`. 
```{r}
bench::mark(
  data.table =DT[order(-v3),.(largest2_v3 = head(v3,2L)),by = id6],
  tidyfst = DT %>%
    in_dt(order(-v3),.(largest2_v3 = head(v3,2L)),by = id6),
  dplyr = DT %>%
    select(id6,largest2_v3 = v3) %>%
    group_by(id6) %>%
    slice_max(largest2_v3,n = 2,with_ties = FALSE),
  check = FALSE,iterations = 10
) -> q3

q3
```
## Q4
  To summarise multiple columns by group, *tidyfst* has designed a function named `summarise_vars`, which is even more convenient than the `across` function in *dplyr*. It first choose the columns, then tell it what to do, and you can provide the "by" parameter to operate by groups (optional).
```{r}
bench::mark(
  data.table =DT[,lapply(.SD,mean),by = id4,.SDcols = v1:v3],
  tidyfst = DT %>%
    summarise_vars(
      v1:v3,
      mean,
      by = id4
    ),
  dplyr = DT %>%
    group_by(id4) %>%
    summarise(across(v1:v3,mean)),
  check = FALSE,iterations = 10
) -> q4

q4
```
   Take a look at the performance, *tidyfst* still lies between *data.table* and *dplyr*.
   
## Q5
  Now let's try more groups, here we use all the id (id1~id6) as group, and get the sum and count. Note that *tidyfst* is written in *data.table*, so it do not use `n()` in *dplyr* but `.N` in *data.table* to get counts by group.

```{r}
bench::mark(
  data.table =DT[,.(v3 = sum(v3),count = .N),by = id1:id6],
  tidyfst = DT %>%
    summarise_dt(
      by = id1:id6,
      v3 = sum(v3),
      count = .N
    ),
  dplyr = DT %>%
    group_by(id1,id2,id3,id4,id5,id6) %>%
    summarise(v3 = sum(v3),count = n()),
  check = FALSE,iterations = 10
) -> q5

q5
```

## Last words
  While in a data set of ~0.5 Mb we find that the performance of *tidyfst* lies between *data.table* and *dplyr*, we could discover that the speed is much closer to *data.table*. In fact, if you try a much larger data set in a computer with large RAM and multiple cores, you'll find that the performance of *tidyfst* sticks close to *data.table*. If you are interested and has a high-performance computer, try to generate a larger data set and test out.  Moreover, while the dplyr user might find these data manipulation verbs friendly, the innate syntax of *tidyfst* is more like *data.table*, and could be a good companion of *data.table* for some frequently used complex tasks.

## Session information
```{r}
sessionInfo()
```

---
title: "Example 5: Fst"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Example 5: Fst}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>",
  eval = FALSE
)
```
 
 The [fst](https://github.com/fstpackage/fst) package for R provides a fast, easy and flexible way to serialize data frames. It has very amazing features, such as fast read and write of R data frames, super file compression and parse data frames without reading it. Considering all these features, now [tidyfst](https://github.com/hope-data-science/tidyfst) could provide a new workflow to manipulate data more efficiently. The core idea is: We never need the whole data all at once, we only need the things we want and aggregate them to get the summary to provide target information. 
 
 *tidyfst* have provided the following functions to facilitate the workflow:
 
- parse_fst: Get information of the data.frame without reading it
- slice_fst: Select the target rows by number
- select_fst: Select the target columns for the task
- filter_fst: Conditional selection of rows
- import_fst: Read a fst file like `fst::read_fst` but always return a data.table
- export_fst: Write a fst file like `fst::write_fst` but always use largest compress factor (which yields smallest file)  

In such a workflow, you never need to read the whole data.frame into your RAM, you just select the target data, process them instantly and get the results all at once. You do not have to read the data to know the structure of data.frame, because we have `parse_fst`(a wrapper for `fst` in *fst* package). Now let's give it a try.
```{r setup}
library(tidyfst)

# Generate some random data frame with 10 million rows and various column types
nr_of_rows <- 1e7

df <- data.frame(
    Logical = sample(c(TRUE, FALSE, NA), prob = c(0.85, 0.1, 0.05), nr_of_rows, replace = TRUE),
    Integer = sample(1L:100L, nr_of_rows, replace = TRUE),
    Real = sample(sample(1:10000, 20) / 100, nr_of_rows, replace = TRUE),
    Factor = as.factor(sample(labels(UScitiesD), nr_of_rows, replace = TRUE))
  )

# write the fst file, make sure you do not have the file with same name in the directory
export_fst(df,"fst_test.fst")

# remove all variables in the environment
rm(list = ls())
```
 Now, we want to know the information in the data frame.
```{r}
parse_fst("fst_test.fst") -> ft
ft
```
 If we want to get the information in the `Factor` column, use:
```{r}
ft %>% 
  select_fst(Factor) %>% 
  count_dt(Factor) -> factor_info

factor_info
```
 If we want to calculate the mean of `Integer` by the group of `Factor`, use:
```{r}
ft %>% 
  select_fst(Integer,Factor) %>% 
  summarise_dt(avg = mean(Integer),by = Factor) -> avg_info

avg_info

```
 In this workflow, we only select/filter/slice the data we need, and get the results directly from the pipeline. Therefore, we read the minimum needed data into RAM and release it and save only the results we want. This workflow could save memory for many exploratory big data analysis.
 Last, let's delete the output file:
```{r}
# delete the output file
unlink("fst_test.fst")
```
 After (>=) version 0.9.3, tidyfst has also added a function `as_fst()`, which can turn any data.frame into a fst table and saved the data in the temporary file. This means that we might never have to save the object in the RAM ever (as long as it is a data.frame)! A small example:
```{r}
iris %>% as_fst() -> iris_fst
mtcars %>% as_fst() -> mtcars_fst

iris_fst
mtcars_fst
```
 So when you have generated a pretty large data.frame and do not want it to consume the cache in your computer, just save it and read it when needed using `as_fst`.
 
 
 

---
title: "Example 6: Dt"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{Example 6: Dt}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```
  For absolute physical speed, use *data.table* directly. While the learning curve might be longer, the improvement of computation performance pays off if you are dealing with large datasets frequently. There are several ways to cut into *data.table* syntax to gain higher performance in *tidyfst*. A convenient way is to use the `DT[I,J,BY]` syntax after the pipe(`%>%`).
```{r setup}
library(tidyfst)
iris %>% 
  as_dt()%>%  #coerce a data.frame to data.table
  .[,.SD[1],by = Species]

```
  This syntax is not so consistent with the tidy syntax, therefore `in_dt` is also designed for the short cut to *data.table* method, which could be used as:
```{r}
iris %>% 
  in_dt(,.SD[1],by = Species)
```
  
  `in_dt` follows the basic principals of *tidyfst*, which include: (1) Never use in place replacement. Therefore, the in place functions like `:=` will still return the results. (2) Always recieves a data frame (data.frame/tibble/data.table) and returns a data.table. This means you don't have to write `as.data.table` or `as_dt` all the time as long as you are working on data frames in R.
 
  
